
/* ---------------------------------------------------------------------------
   A. Veneziani -  Programma per l'esecuzione controllata di due thread

                   Scritto in Borland C++ Builder 6

  --------------------------------------------------------------------------- */                   

#include <vcl.h>
#pragma hdrstop

#include "thr_cntrl.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

// classe MyTh - derivata da TThread
// implementa il multithreading
class MyTh: public TThread
{

  public:

  int nth, rit;

 // costruttore della classe derivata MyTh
   __fastcall MyTh(bool CreateSuspended)
             : TThread(CreateSuspended)
   {
   }

   // riscrittura del metodo Execute della
   // classe derivata MyTh da TThread
    void _fastcall Execute()
    {
       // ciclo infinito di esecuzione
       while (true)
       {
           // produzione delle scritte di output dei thread
           Form1->memOut->Text = "Thread " + IntToStr(nth) + "\r" + "\n" +
                                 Form1->memOut->Text;
           Sleep(100 * rit);     // ritardo - regolazione della velocita' di exec.
       }
    }
};

// Oggetti thread della classe MyTh
MyTh *Th1, *Th2;

//---------------------------------------------------------------------------
// creazione di due thread all' inizio del programma
// ed inizializzazione dei valori all' interno dei due thread
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
    // crea il puntatore al primo oggetto thread
    Th1 = new MyTh(true);
    Th1->nth = 1;            // setta un identificatore per il thread 1
    Th1->rit = 10;       // setta il ritardo massimo di esec. per il thread 1
    // crea il puntatore al secondo oggetto thread    
    Th2 = new MyTh(true);
    Th2->nth = 2;         // idem come sopra per il thread 2
    Th2->rit = 10;       // idem come sopra per il thread 2
}
//---------------------------------------------------------------------------
// avvia o ferma l'esecuzione del thread 1 
void __fastcall TForm1::btnThr1Click(TObject *Sender)
{
    if (btnThr1->Caption == "Avvia")
    {
        Th1->Resume();               // avvia il thread 1
        btnThr1->Caption = "Ferma";
    }
    else
    {
        Th1->Suspend();              // ferma il thread 1
        btnThr1->Caption = "Avvia";
    }
}
//---------------------------------------------------------------------------
// avvia o ferma l'esecuzione del thread 2
void __fastcall TForm1::btnThr2Click(TObject *Sender)
{
    if (btnThr2->Caption == "Avvia")
    {
        Th2->Resume();                 // avvia il thread 2
        btnThr2->Caption = "Ferma";
    }
    else
    {
        Th2->Suspend();               // ferma il thread 2
        btnThr2->Caption = "Avvia";
    }
}
//---------------------------------------------------------------------------
// regola la velocit di esecuzione del thread 1
// impostando un valore per la variabile rit
void __fastcall TForm1::trkThr1Change(TObject *Sender)
{
   Th1->rit = 10 - trkThr1->Position;     // regola la velocita' del thread 1
}
//---------------------------------------------------------------------------
// regola la velocit di esecuzione del thread 2
// impostando un valore per la variabile rit
void __fastcall TForm1::trkThr2Change(TObject *Sender)
{
   Th2->rit = 10 - trkThr2->Position;    // regola la velocita' del thread 1
}
//---------------------------------------------------------------------------
